<?php

/**
* $Id: faq.php,v 1.27.2.12 2005/05/30 17:38:00 fx2024 Exp $
* Module: SmartFAQ
* Author: The SmartFactory <www.smartfactory.ca>
* Licence: GNU
*/

include_once("header.php");

$faqid = isset($_GET['faqid']) ? intval($_GET['faqid']) : 0;

If ($faqid == 0) {
	redirect_header("javascript:history.go(-1)", 1, _MD_SF_NOFAQSELECTED);
	exit();
}

// Creating the FAQ handler object
$faq_handler =& sf_gethandler('faq');

// Creating the FAQ object for the selected FAQ
$faqObj = new sfFaq($faqid);

// If the selected FAQ was not found, exit
If ($faqObj->notLoaded()) {
	redirect_header("javascript:history.go(-1)", 1, _MD_SF_NOFAQSELECTED);
	exit();
}

// Creating the category object that holds the selected FAQ
$categoryObj =& $faqObj->category();

// Creating the answer object
$answerObj =& $faqObj->answer();

// Check user permissions to access that category of the selected FAQ

$faqAccessGrantedResult = faqAccessGranted($faqObj);
if ($faqAccessGrantedResult < 0) {
	redirect_header("javascript:history.go(-1)", 1, _NOPERM);
	exit;
}

// Update the read counter of the selected FAQ
if (!$xoopsUser || ($xoopsUser->isAdmin($xoopsModule->mid()) && $xoopsModuleConfig['adminhits'] == 1) || ($xoopsUser && !$xoopsUser->isAdmin($xoopsModule->mid()))) {
	$faqObj->updateCounter();
}
$xoopsOption['template_main'] = 'smartfaq_faq.html';
include_once(XOOPS_ROOT_PATH . "/header.php");
include_once("footer.php");

$faq = $faqObj->toArray(null, $categoryObj, false);

$withAllLink = (sf_getConfig('displaytype') == 'treeview' && $_SESSION["osBrowserOk"]) ? 0 : 2;

$faq['categoryPath'] = $categoryObj->getCategoryPath($withAllLink);
$faq['answer'] = $answerObj->answer();

// Hightlighting searched words
$highlight = true;
if($highlight && isset($_GET['keywords']))
{
	$myts =& MyTextSanitizer::getInstance();
	$keywords=$myts->htmlSpecialChars(trim(urldecode($_GET['keywords'])));
	$h= new SmartfaqKeyhighlighter ($keywords, true , 'smartfaq_highlighter');
	$faq['answer'] = $h->highlight($faq['answer']);
}

// For diduno type, if no answer, it is set to '-', we need to not display this '-'
// A better solution for diduno type will be implemented soon ;-)
if ($faq['answer'] == '-') {
	$faq['answer'] = ' ';
}


// Check to see if we need to display partial answer. This should probably be in a the FAQ class...
if ($faqAccessGrantedResult == 0) {
	$faq['answer'] = sf_substr($faq['answer'], 0, sf_getConfig('partialview_count'));
	$xoopsTpl->assign('partialview_msg', sf_getConfig('partialview_msg'));
}

$faq['who_when'] = $faqObj->getWhoAndWhen();

$faq['adminlink'] = sf_getAdminLinks($faqObj->faqid());

$faq['comments'] = $faqObj->comments();

// Language constants
$xoopsTpl->assign('faq', $faq);
$xoopsTpl->assign('display_categoryname', false);
$xoopsTpl->assign('faqfooter', $myts->displayTarea($xoopsModuleConfig['faqfooter']));
$xoopsTpl->assign('display_poster_info', sf_getConfig('display_poster_info'));
$xoopsTpl->assign('com_rule', sf_getConfig('com_rule'));
$xoopsTpl->assign('back2index', sf_getConfig('back2index'));

$xoopsTpl->assign('xcodes', $faqObj->getVar('xcodes'));
$xoopsTpl->assign('mail_link', 'mailto:?subject=' . sprintf(_MD_SF_INTARTICLE, $xoopsConfig['sitename']) . '&amp;body=' . sprintf(_MD_SF_INTARTFOUND, $xoopsConfig['sitename']) . ':  ' . XOOPS_URL . '/modules/' . $xoopsModule->dirname() . '/faq.php?faqid=' . $faqObj->getVar('faqid'));
$xoopsTpl->assign('lang_printerpage', _MD_SF_PRINTERFRIENDLY);
$xoopsTpl->assign('lang_sendstory', _MD_SF_SENDSTORY);
$xoopsTpl->assign('lang_back2index', _MD_SF_BACK2INDEX);
$xoopsTpl->assign('faqid', $faqObj->getVar('faqid'));
$xoopsTpl->assign('lang_reads', _MD_SF_READS);
$xoopsTpl->assign('lang_beenread', sprintf(_MD_SF_BEENREAD, $faq['counter']));
$xoopsTpl->assign('lang_home', _MD_SF_HOME);
$xoopsTpl->assign('lang_faq', _MD_SF_FAQ);
$xoopsTpl->assign('lang_postedby', _MD_SF_POSTEDBY);
$xoopsTpl->assign('lang_on', _MD_SF_ON);
$xoopsTpl->assign('lang_datesub', _MD_SF_DATESUB);
$xoopsTpl->assign('lang_hitsdetail', _MD_SF_HITSDETAIL);
$xoopsTpl->assign('lang_hits', _MD_SF_READS);
$xoopsTpl->assign('lang_comments', _MD_SF_COMMENTS);

// Page Title Hack by marcan
$module_name = $myts->makeTboxData4Show($xoopsModule->getVar('name'));
$xoopsTpl->assign('xoops_pagetitle', $faq['question'] . ' - ' . $categoryObj->name(). ' - ' . $module_name);
// End Page Title Hack by marcan

// Include the comments if the selected FAQ supports comments
if ($faqObj->cancomment() == 1) {
	include_once XOOPS_ROOT_PATH . "/include/comment_view.php";
}
smartfaq_createMetaTags($faqObj->question(),$faq['categoryPath'],$faqObj->question());
if (file_exists(XOOPS_ROOT_PATH . '/modules/smarttie/smarttie_links.php')) {
	include_once XOOPS_ROOT_PATH . '/modules/smarttie/smarttie_links.php';
	$xoopsTpl->assign('smarttie',1);
}
include_once XOOPS_ROOT_PATH . '/footer.php';

?>